#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

int n, m;
vector<vector<int>> g;

pair<int, int> dfs(int v) {
    if (v >= n) return {v - n, v - n};

    vector<pair<int, int>> res;
    for (int u : g[v]) res.push_back(dfs(u));
    sort(all(res));

    for (int i = 1; i < res.size(); i++) {
        if (res[i].first < res[i - 1].second) return {-1, m};
    }
    return {res[0].first, res.back().second};
}

int main() {

    cin >> n >> m;
    vector<int> a(m);
    cin >> a;
    for (int &i : a) i--;

    g.resize(n);
    for (int i = 1; i < n; i++) {
        in(int, pi)
        g[--pi].push_back(i);
    }
    for (int i = 0; i < m; i++) {
        in(int, pi);
        g[--pi].push_back(a[i] + n);
    }

    auto res = dfs(0);
    cout << (res.first > -1 ? "YES" : "NO") << '\n';

}