#include "testlib.h"

using namespace std;

#define all(c) c.begin(), c.end()

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), limit = opt<int>("limit");

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = rnd.next(1, limit);
    }
    sort(all(a));

    auto p1 = rnd.perm(n / 2, 1);
    auto p2 = rnd.perm((n + 1) / 2, n / 2 + 1);
    copy(all(p2), back_inserter(p1));

    println(n);
    println(all(a));
    println(all(p1));

}