#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n)
    vector<int> a(n), p(n);
    cin >> a >> p;
    for (int &i : p) i--;

    int ans = 0;
    vector<int> cycle;
    vector<int> used(n);
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        cycle.clear();
        int cur = i;
        while (!used[cur]) {
            cycle.push_back(cur);
            used[cur] = true;
            cur = p[cur];
        }

        int q = cycle.size();
        for (int j = 0; j < q; j++) cycle.push_back(cycle[j]);
        unordered_map<int, int> last;
        for (int j = 0; j < 2 * q; j++) {
            if (j >= q) ans = max(ans, j - last[a[cycle[j]]]);
            last[a[cycle[j]]] = j;
        }
    }

    cout << ans << '\n';

}