#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), q = opt<int>("q");
    char let = opt<string>("let")[0];
    double alpha = opt<double>("alpha"), beta = opt<double>("beta");

    string s;
    for (int i = 0; i < n; i++) {
        s.push_back(rnd.next('a', let));
    }

    println(s);
    println(q);

    int low = max(3, (int) sqrt(n) / 5);
    int high = max(1, n / 3);

    for (int i = 0; i < q; i++) {
        if (rnd.next() < alpha) {
            if (rnd.next(0, 1)) {
                int pos = rnd.next(1, n);
                char c = rnd.next('a', let);
                println(1, pos, c);
            } else {
                char c1 = rnd.next('a', let);
                char c2 = rnd.next('a', let);
                while (c1 == c2) c2 = rnd.next('a', let);
                println(2, c1, c2);
            }
        } else {
            int len = rnd.next() < beta ? rnd.wnext(1, low, -1) : rnd.wnext(high, min(2 * high, n), -1);
            int l1 = rnd.next(0, n - len), l2 = rnd.next(0, n - len);
            println(3, l1 + 1, l1 + len, l2 + 1, l2 + len);
        }
    }

}