using namespace std;

//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <stack>
#include <queue>
#include <tuple>
#include <map>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';cout.flush();
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define X first
#define Y second

const ull MOD = 1000000007;

ull powmod(ull a, ull b) {
    if (b == 0) {
        return 1;
    } else if (b == 1) {
        return a % MOD;
    }
    ull c = powmod(a, b / 2);
    c = (c * c) % MOD;
    return (b % 2 == 1) ? (c * a) % MOD : c;
}

class DSU {
    vector<int> p, w;
public:
    DSU(int n) : p(n), w(n, 0) {
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
    }

    int find(int v) {
        while (p[v] != v) {
            v = p[v];
        }
        return v;
    }

    void join(int a, int b) {
        a = find(a);
        b = find(b);
        if (a == b) return;
        if (w[a] == w[b]) w[a]++;
        if (w[a] < w[b]) p[a] = b;
        else p[b] = a;
    }
};


void solver() {
    int a, b, c;
    cin >> a >> b >> c;

    auto get_len = [a, b, c](char x, char y) {
        int n = x == 'a' ? a : (x == 'b' ? b : c);
        int m = y == 'a' ? a : (y == 'b' ? b : c);
        int k = n + m;
        return mp(n, k);
    };
    auto get_pos = [a, b, get_len](char x, char y, int p) {
        auto pp = get_len(x, y);
        int n = pp.X;
        int k = pp.Y;
        if (p < n) {
            return x == 'a' ? p : (x == 'b' ? (p + a) : (p + a + b));
        } else {
            int q = p - n;
            return y == 'a' ? q : (y == 'b' ? (q + a) : (q + a + b));
        }
    };

    DSU dsu(a + b + c);
    for (char x = 'a'; x <= 'c'; ++x) {
        for (char y = x; y <= 'c'; ++y) {
            if (y == x) { continue; }
            int k = get_len(x, y).Y;
            int l = k / 2;
            fori(i, l) {
                dsu.join(get_pos(x, y, i), get_pos(x, y, k - 1 - i));
            }
        }
    }
    ull indep = 0;
    fori(i, a + b + c) {
        if (dsu.find(i) == i) ++indep;
    }
    cout << powmod(10, indep) << "\n";
}

int main() {
//    fastio;
    solver();
}