#include "jngen.h"
std::mt19937 rndd(238);
using namespace std;
typedef long long ll;

const int maxN = 200'000;
const int maxM = 200'000;
const int maxK = maxN;

void gen1() {
    int n = rnd.next(1, maxN);
    int m = rnd.next(n - 1, maxM);
    int l = rnd.next(1, n / 2);
    int k = rnd.next(1, n / 2);
    cout << n << ' ' << m << ' ' << k << ' ' << l << '\n';
    vector<int> used;

    for (int i = 0; i < l; i++) {
        used.push_back(2);
    }

    for (int i = 0; i < k; i++) {
        used.push_back(1);
    }

    while (used.size() != n) {
        used.push_back(0);
    }
    shuffle(used.begin(), used.end(), rndd);

    vector<int> kek;
    for (int i = 0; i < n; i++) {
        if (used[i] == 1) {
            kek.push_back(i + 1);
        }
    }
    shuffle(kek.begin(), kek.end(), rndd);
    for (int i = 0; i < kek.size(); i++) {
        cout << kek[i];
        if (i != kek.size() - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }
    kek.clear();


    for (int i = 0; i < n; i++) {
        if (used[i] == 2) {
            kek.push_back(i + 1);
        }
    }
    shuffle(kek.begin(), kek.end(), rndd);
    for (int i = 0; i < kek.size(); i++) {
        cout << kek[i];
        if (i != kek.size() - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }

    Graph g2 = Graph::random(n, m).allowMulti(false).allowLoops(false).connected(true).g().shuffled();
    for (auto i : g2.edges()) {
        cout << i.first + 1 << ' ' << i.second + 1 << endl;
    }
}

void gen2() {
    int n = maxN;
    int m = maxM;
    int l = rnd.next(1, n / 2);
    int k = rnd.next(1, n / 2);
    cout << n << ' ' << m << ' ' << k << ' ' << l << '\n';
    vector<int> used;

    for (int i = 0; i < l; i++) {
        used.push_back(2);
    }

    for (int i = 0; i < k; i++) {
        used.push_back(1);
    }

    while (used.size() != n) {
        used.push_back(0);
    }
    shuffle(used.begin(), used.end(), rndd);

    vector<int> kek;
    for (int i = 0; i < n; i++) {
        if (used[i] == 1) {
            kek.push_back(i + 1);
        }
    }
    shuffle(kek.begin(), kek.end(), rndd);
    for (int i = 0; i < kek.size(); i++) {
        cout << kek[i];
        if (i != kek.size() - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }
    kek.clear();


    for (int i = 0; i < n; i++) {
        if (used[i] == 2) {
            kek.push_back(i + 1);
        }
    }
    shuffle(kek.begin(), kek.end(), rndd);
    for (int i = 0; i < kek.size(); i++) {
        cout << kek[i];
        if (i != kek.size() - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }

    Graph g2 = Graph::random(n, m).allowMulti(false).allowLoops(false).connected(true).g().shuffled();
    for (auto i : g2.edges()) {
        cout << i.first + 1 << ' ' << i.second + 1 << endl;
    }
}

void gen3() {
    int n = rnd.next(1, maxN);
    int m = rnd.next(n - 1, maxM);
    int l = 1;
    int k = rnd.next(1, n - 1);
    cout << n << ' ' << m << ' ' << k << ' ' << l << '\n';
    vector<int> used;

    for (int i = 0; i < l; i++) {
        used.push_back(2);
    }

    for (int i = 0; i < k; i++) {
        used.push_back(1);
    }

    while (used.size() != n) {
        used.push_back(0);
    }
    shuffle(used.begin(), used.end(), rndd);


    vector<int> kek;
    for (int i = 0; i < n; i++) {
        if (used[i] == 1) {
            kek.push_back(i + 1);
        }
    }
    shuffle(kek.begin(), kek.end(), rndd);
    for (int i = 0; i < kek.size(); i++) {
        cout << kek[i];
        if (i != kek.size() - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }
    kek.clear();


    for (int i = 0; i < n; i++) {
        if (used[i] == 2) {
            kek.push_back(i + 1);
        }
    }
    shuffle(kek.begin(), kek.end(), rndd);
    for (int i = 0; i < kek.size(); i++) {
        cout << kek[i];
        if (i != kek.size() - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }

    Graph g2 = Graph::random(n, m).allowMulti(false).allowLoops(false).connected(true).g().shuffled();
    for (auto i : g2.edges()) {
        cout << i.first + 1 << ' ' << i.second + 1 << endl;
    }
}

void gen4() {
    int n = rnd.next(1, maxN);
    int m = rnd.next(n - 1, maxM);
    int k = 1;
    int l = rnd.next(1, n - 1);
    cout << n << ' ' << m << ' ' << k << ' ' << l << '\n';
    vector<int> used;

    for (int i = 0; i < l; i++) {
        used.push_back(2);
    }

    for (int i = 0; i < k; i++) {
        used.push_back(1);
    }

    while (used.size() != n) {
        used.push_back(0);
    }
    shuffle(used.begin(), used.end(), rndd);

    vector<int> kek;
    for (int i = 0; i < n; i++) {
        if (used[i] == 1) {
            kek.push_back(i + 1);
        }
    }
    shuffle(kek.begin(), kek.end(), rndd);
    for (int i = 0; i < kek.size(); i++) {
        cout << kek[i];
        if (i != kek.size() - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }
    kek.clear();


    for (int i = 0; i < n; i++) {
        if (used[i] == 2) {
            kek.push_back(i + 1);
        }
    }
    shuffle(kek.begin(), kek.end(), rndd);
    for (int i = 0; i < kek.size(); i++) {
        cout << kek[i];
        if (i != kek.size() - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }

    Graph g2 = Graph::random(n, m).allowMulti(false).allowLoops(false).connected(true).g().shuffled();
    for (auto i : g2.edges()) {
        cout << i.first + 1 << ' ' << i.second + 1 << endl;
    }
}

void gen6() {
    int n = maxN;
    int m = n - 1;
    int l = 5;
    int k = 5;
    cout << n << ' ' << m << ' ' << k << ' ' << l << '\n';
    vector<int> used;

    for (int i = 0; i < l; i++) {
        used.push_back(2);
    }

    for (int i = 0; i < k; i++) {
        used.push_back(1);
    }

    while (used.size() != n) {
        used.push_back(0);
    }
    shuffle(used.begin(), used.end(), rndd);

    vector<int> kek;
    for (int i = 0; i < n; i++) {
        if (used[i] == 1) {
            kek.push_back(i + 1);
        }
    }
    shuffle(kek.begin(), kek.end(), rndd);
    for (int i = 0; i < kek.size(); i++) {
        cout << kek[i];
        if (i != kek.size() - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }
    kek.clear();


    for (int i = 0; i < n; i++) {
        if (used[i] == 2) {
            kek.push_back(i + 1);
        }
    }
    shuffle(kek.begin(), kek.end(), rndd);
    for (int i = 0; i < kek.size(); i++) {
        cout << kek[i];
        if (i != kek.size() - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }

    Graph g2 = Tree::bamboo(n).shuffled();
    for (auto i : g2.edges()) {
        cout << i.first + 1 << ' ' << i.second + 1 << endl;
    }
}

void gen5(int n, int m, int k, int l) {
    m = max(n - 1, m);
    cout << n << ' ' << m << ' ' << k << ' ' << l << '\n';
    vector<int> used;

    for (int i = 0; i < l; i++) {
        used.push_back(2);
    }

    for (int i = 0; i < k; i++) {
        used.push_back(1);
    }

    while (used.size() != n) {
        used.push_back(0);
    }
    shuffle(used.begin(), used.end(), rndd);

    vector<int> kek;
    for (int i = 0; i < n; i++) {
        if (used[i] == 1) {
            kek.push_back(i + 1);
        }
    }
    shuffle(kek.begin(), kek.end(), rndd);
    for (int i = 0; i < kek.size(); i++) {
        cout << kek[i];
        if (i != kek.size() - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }
    kek.clear();


    for (int i = 0; i < n; i++) {
        if (used[i] == 2) {
            kek.push_back(i + 1);
        }
    }
    shuffle(kek.begin(), kek.end(), rndd);
    for (int i = 0; i < kek.size(); i++) {
        cout << kek[i];
        if (i != kek.size() - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }

    Graph g2 = Graph::random(n, m).allowMulti(false).allowLoops(false).connected(true).g().shuffled();
    for (auto i : g2.edges()) {
        cout << i.first + 1 << ' ' << i.second + 1 << endl;
    }
}


int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    string type = argv[1];
    if (type == "rnd") {
        gen1();
    } else if (type == "max") {
        gen2();
    } else if (type == "oneL") {
        gen3();
    } else if (type == "oneK") {
        gen4();
    } else if (type == "bam") {
        gen6();
    } else {
        int n = atoi(argv[2]);
        int m = atoi(argv[3]);
        int k = atoi(argv[4]);
        int l = atoi(argv[5]);
        gen5(n, m, k, l);
    }


    return 0;
}
