#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<vector<int>> g, gr;
vector<int> ord, cmp, used;
void dfs(int v) {
    used[v] = 1;
    for (auto i : g[v]) {
        if (!used[i]) {
            dfs(i);
        }
    }
    ord.push_back(v);
}
int c;
void dfs2(int v) {
    used[v] = 1;
    cmp[v] = c;
    for (auto i : gr[v]) {
        if (!used[i]) {
            dfs2(i);
        }
    }
}

void solve() {
    int n, m, k, l;
    cin >> n >> m >> k >> l;
    vector<int> w(n);
    for (int i = 0; i < k; i++) {
        int x;
        cin >> x;
        w[x - 1] = 1;
    }
    queue<int> q;
    g.resize(n);
    vector<int> d(n, 1e9);
    vector<int> h(n);
    for (int i = 0; i < l; i++) {
        int x;
        cin >> x;
        h[x - 1] = 1;
        d[x - 1] = 0;
        q.push(x - 1);
    }

    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }

    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (auto i : g[v]) {
            if (d[i] > d[v] + 1) {
                d[i] = d[v] + 1;
                q.push(i);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (w[i]) {
            ans = max(ans, d[i]);
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int _ = 1;
    //cin >> _;
    for (int i = 1; i <= _; i++) {
        solve();
    }
    return 0;
}
