#include "bits/stdc++.h"
#include "testlib.h"

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()

#ifdef CLOWN
#include "trash.h"
#define dbg(...) cout << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__);
#else
#define dbg(...);
#endif

int test = 0;

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

const int maxn = 1e5;

vector<int> g[maxn];
int used[maxn];

void dfs(int u, int p = -1) {
    used[u] = 1;
    for (auto v : g[u]) {
        if (v ^ p) {
            ensuref(!(used[v]), "graph must be a tree");
            dfs(v, u);
        }
    }
}

void solve() {
    int n = inf.readInt(2, maxn, "n");
    inf.readSpace();
    int k = inf.readInt(1, 6, "k");
    inf.readEoln();
    for (int i = 0; i < n; i++) {
        int a = inf.readInt(0, k, "a");
        if (i != n - 1) inf.readSpace();
    }
    inf.readEoln();
    for (int i = 0; i < n - 1; i++) {
        int u = inf.readInt(1, n, "u");
        inf.readSpace();
        int v = inf.readInt(1, n, "v");
        inf.readSpace();
        int c = inf.readInt(1, (int)1e9, "c");
        inf.readEoln();
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    dfs(0);
    for (int i = 0; i < n; i++) {
        ensuref(used[i], "graph must be a tree");
    }
    inf.readEof();
}

int32_t main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int t = 1;
    fastio();
    if (test) cin >> t;
    while (t--) { solve(); }
    return 0;
}
