#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef tree<pair<int, int>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const double K = 180.0 / 3.14159265358979;

void solve() {
    double d, h, w, k;
    cin >> d >> h >> w >> k;
    if (k < 2 * d) {
        cout << "-1\n";
        return;
    }
    double minAngle = atan2(w, d);
    double k2 = k * k, d4 = 4 * d * d, h2 = k2 - d4;
    double hSq = sqrt(h2);
    double ang = atan2(hSq, 2 * d);
    double ans = 1000.0;
    if (ang >= minAngle) {
        ans = min(ans, ang * K);
    }
    if (h >= 2 * w && 4 * (w * w + d * d) <= k2) {
        ans = min(ans, minAngle * K);
    }
    cout << (ans > 900.0 ? -1 : ans) << '\n';
}

bool multitest = false;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cout.precision(25);
    size_t number_of_tests = 1;
    if (multitest) {
        cin >> number_of_tests;
    }
    for (size_t _ = 0; _ < number_of_tests; ++_) {
        solve();
    }
    return 0;
}