/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }
 
struct point {
	long double x, y;
	point(long double x_ = 0, long double y_ = 0): x(x_), y(y_) {};
	point operator +(point p) {
		return point(x + p.x, y + p.y);
	}
	point operator -(point p) {
		return point(x - p.x, y - p.y);
	}
	point operator /(long double q) {
		return point(x / q, y / q);
	}
	point operator *(long double q) {
		return point(x * q, y * q);
	}
	void norm() {
		long double q = sqrt(x * x + y * y);
		x /= q;
		y /= q;
	}
	void perp() {
		swap(x, y);
		y *= -1;
	}
	long double dist(point p) {
		return (x - p.x) * (x - p.x) + (y - p.y) * (y - p.y);
	}
	long double dist2(point p) {
		return sqrt((x - p.x) * (x - p.x) + (y - p.y) * (y - p.y));
	}
};
 
const long double eps = 1e-8;

void solve() {
	int n;
	cin >> n;
	vector<point> mas(n);
	for (int i = 0; i < n; i++) {
		cin >> mas[i].x >> mas[i].y;
	}
	long double le = 0, ri = 2e5;
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++)
			le = min(le, mas[i].dist(mas[j]));
	le = sqrt(le) / 2;
	
	auto check = [&](point center, long double d) {
		//cout << center.x << " " << center.y << " " << d << endl;
		int cnt = 0;
		for (int i = 0; i < n; i++) {
			if (center.dist2(mas[i]) < d + eps)
				cnt++;
			if (2 * cnt >= n)
				return true;
		}
		return false;
	};
	
	//cout << check(point(0, 0), 5) << endl;
	point last, right;
	for (int qwe = 0; qwe < 40; qwe++) {
		//cerr << qwe << endl;
		long double mi = (le + ri) / 2;
		bool ok = 0;
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				point mid = (mas[i] + mas[j]) / 2;
				point kek = (mas[j] - mas[i]);
				kek.perp();
				kek.norm();
				//cout << i << " " << j << " " << mid.x << " " << mid.y << " " << kek.x << " " << kek.y << "\n";
				long double lol = mid.dist(mas[i]);
				if (mi * mi < lol)
					continue;
				kek = kek * sqrt(mi * mi - lol);
				if (check(mid + kek, mi)) {
					ok = 1;
					last = mid + kek;
					break;
				}
				if (check(mid - kek, mi)) {
					ok = 1;
					last = mid - kek;
					break;
				}
			}
			if (ok)
				break;
		}
		if (ok) {
			ri = mi;
			right = last;
		}
		else
			le = mi;
	}
	//cerr << "done" << endl;
	cout << right.x << " " << right.y << " " << ri << endl;
}
 
 
int main() {
#ifdef LOCAL
	clock_t start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}