using namespace std;

#include <unordered_set>
#include <queue>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");
    int max_s = opt<int>("s");
    auto max_x = opt<long long>("x");

    int n = 1 + rnd.wnext(max_n, 3);
    int s = 1 + rnd.wnext(max_s, 3);

    vector<long long> a(n);
    for (int i = 0; i < s; ++i) {
        int x = rnd.next(0, n - 1);
        int y = rnd.next(0, n - 1);
        if (x > y) {
            swap(x, y);
        }
        long long w = rnd.next(1LL, max_x);
        for (int j = x; j <= y; ++j) {
            a[j] += w;
        }
    }
    printf("%d\n", n);
    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            printf(" ");
        }
        printf("%lld", a[i]);
    }
    printf("\n");
}

