using namespace std;

#include <unordered_set>
#include <queue>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");
    int max_m = opt<int>("m");

    int n = 1 + rnd.wnext(max_n, 3);
    int m = 1 + rnd.wnext(max_m, 3);
    printf("%d %d\n", n, m);

    vector<int> pp;
    vector<pair<int, char>> es;
    for (int i = 0; i < m; ++i) {
        if (rnd.next(0, 1) == 1 && !pp.empty()) {
            int pos = rnd.next(0, (int)pp.size() - 1);
            es.emplace_back(pp[pos], '-');
            pp[pos] = pp.back();
            pp.pop_back();
        } else {
            int k = rnd.next(1, n);
            es.emplace_back(k, '+');
            pp.push_back(k);
        }
    }

    for(auto& e : es) {
        printf("%d %c\n", e.first, e.second);
    }
}

