#include <functional>
#include <algorithm>
#include "testlib.h"

using namespace std;

const int max_n = 1'00'000;
const int max_m = 3'00'000;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, max_n, "n");
    inf.readSpace();
    int m = inf.readInt(1, max_m, "m");
    inf.readEoln();
    vector<int> b(n + 1);
    for (int i = 0; i < m; ++i) {
        int a_i = inf.readInt(1, n, "a_i");
        inf.readSpace();
        char op = inf.readChar();
        inf.ensuref(op == '+' || op == '-', "op must be + or -");
        if (op == '+') {
            b[a_i]++;
        } else {
            inf.ensuref(b[a_i]-- > 0, "no people to leave");
        }
        inf.readEoln();
    }
    inf.readEof();
}