using namespace std;

#include "testlib.h"

typedef long long ll;

const int maxN = 200'000;
const int maxM = 200'000;
const int maxK = maxN;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    int n = inf.readInt(1, maxN, "n");
    inf.readSpace();
    int m = inf.readInt(1, maxM, "m");
    inf.readSpace();
    int k = inf.readInt(1, min(n, maxK), "k");
    inf.readSpace();
    int l = inf.readInt(1, n, "l");
    inf.readEoln();

    set<int> w;
    for (int i = 0; i < k; i++) {
        int a = inf.readInt(1, n, "a");
        if (i != k - 1) {
            inf.readSpace();
        } else {
            inf.readEoln();
        }
        w.insert(a);
    }
    ensuref(w.size() == k, "not distinct K");
    w.clear();
    for (int i = 0; i < l; i++) {
        int a = inf.readInt(1, n, "a");
        w.insert(a);
        if (i != l - 1) {
            inf.readSpace();
        } else {
            inf.readEoln();
        }
    }
    ensuref(w.size() == l, "not distinct L");


    for (int i = 0; i < m; i++) {
        int u = inf.readInt(1, n, "u");
        inf.readSpace();
        int v = inf.readInt(1, n, "v");
        inf.readEoln();
        ensuref(u != v, "v == u");
    }

    inf.readEof();
    return 0;
}
