#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

int n, m;
vector<int> p, q;
vector<vector<int>> g;
vector<int> d;

int main() {

    cin >> n >> m;
    in(int, s, t)
    p.resize(s), q.resize(t);
    g.resize(n), d.resize(n, n + 1);

    cin >> p >> q;
    for (int &i : p) i--;
    for (int &i : q) i--;

    for (int i = 0; i < m; i++) {
        in(int, u, v)
        g[--u].push_back(--v);
        g[v].push_back(u);
    }

    deque<int> qu;
    for (int i : q) {
        qu.push_back(i);
        d[i] = 0;
    }
    while (!qu.empty()) {
        int v = qu.front();
        qu.pop_front();
        for (int u : g[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                qu.push_back(u);
            }
        }
    }

    int l = -1, r = *max_element(all(d));
    vector<int> ans(n + 1);
    ans[r] = 0;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        vector<int> rd(n, 0);
        for (int pi : p) {
            if (d[pi] > mid) {
                deque<int> qu2{pi};
                vector<int> d2(n, n + 1);
                d2[pi] = 0;
                while (!qu2.empty()) {
                    int v = qu2.front();
                    if (d2[v] > mid) break;
                    qu2.pop_front();
                    for (int u : g[v]) {
                        if (d2[u] > d2[v] + 1) {
                            d2[u] = d2[v] + 1;
                            qu2.push_back(u);
                        }
                    }
                }
                for (int i = 0; i < n; i++) {
                    rd[i] = max(rd[i], d2[i]);
                }
            }
        }
        bool ok = false;
        int sol = -1;
        for (int i = 0; i < n; i++) {
            if (rd[i] <= mid) {
                ok = true;
                sol = i;
                break;
            }
        }
        if (ok) {
            r = mid;
            ans[r] = sol;
        } else {
            l = mid;
        }
    }

    cout << ans[r] + 1 << ' ' << r << '\n';

}